import "Turbine.UI"; 
import "Turbine.UI.Lotro"; 
import "Turbine.Gameplay"
import "Turbine.Debug"
import "Turbine.UI.Extensions"
import "Iinferno.debuffhelper.timer"
--import "Iinferno.debuffhelper.skillhelper.SkillInfo"

debuffBar = class(Turbine.UI.Extensions.SimpleWindow );
function debuffBar:Constructor()
	Turbine.UI.Extensions.SimpleWindow.Constructor( self );
	
	--self.quickslotSize = 36;
	--self.quickslots = { };
	self:LoadSettings()
	self.width = 300;
	self.height = 46;
	self:SetSize( self.width , self.height );
	self:SetVisible(true);
	if not self.settings.positionX and not self.settings.positionY then
		self:SetPosition((Turbine.UI.Display.GetWidth() / 2) - 150 , Turbine.UI.Display.GetHeight() / 2 + 150)
		else
		self:SetPosition(self.settings.positionX , self.settings.positionY)
	end
	--[[
		self.quickslot1 = Turbine.UI.Lotro.Quickslot();		
		self.quickslot1:SetParent( self );
		self.quickslot1:SetZOrder(100);
		self.quickslot1:SetSize(36, 36);
		Turbine.Shell.WriteLine("working up to line 21");
	--self.quickslot1:SetVisible(true);]]
	
	debuffs = {firelore = "0x70003EBE", windlore =  "0x70003EBF", frostlore = "0x70024BE7", ancientcraft = "0x7000B627", allends = "0x7000F801", sopc = "0x70028B80", gustofwind = "0x70003EB7"}
	
	--debuff slot: SoP:SaE
	self.quickslot1 = Turbine.UI.Lotro.Quickslot();		
	self.quickslot1:SetParent( self );
	self.quickslot1:SetZOrder(100);
	self.quickslot1:SetSize(36, 36);
	self.quickslot1:SetPosition(0 , self.height/36);
	self.quickslot1:SetShortcut( Turbine.UI.Lotro.Shortcut ( 6.0,  debuffs.allends ));
	
	
	--debuff slot: Ancient Craft
	self.quickslot2 = Turbine.UI.Lotro.Quickslot();		
	self.quickslot2:SetParent( self );
	self.quickslot2:SetZOrder(100);
	self.quickslot2:SetSize(36, 36);
	self.quickslot2:SetPosition(36 , self.height/36)
	self.quickslot2:SetShortcut( Turbine.UI.Lotro.Shortcut ( 6.0,  debuffs.ancientcraft ));
	
	--debuff slot: Wind Lore
	self.quickslot3 = Turbine.UI.Lotro.Quickslot();		
	self.quickslot3:SetParent( self );
	self.quickslot3:SetZOrder(100);
	self.quickslot3:SetSize(36, 36);
	self.quickslot3:SetPosition(72 , self.height/36)
	self.quickslot3:SetShortcut( Turbine.UI.Lotro.Shortcut ( 6.0,  debuffs.windlore ));
	
	--debuff slot: Fire Lore
	self.quickslot4 = Turbine.UI.Lotro.Quickslot();		
	self.quickslot4:SetParent( self );
	self.quickslot4:SetZOrder(100);
	self.quickslot4:SetSize(36, 36);
	self.quickslot4:SetPosition(108 , self.height/36)
	self.quickslot4:SetShortcut( Turbine.UI.Lotro.Shortcut ( 6.0,  debuffs.firelore ));
	
	--debuff slot: Frost Lore
	self.quickslot5 = Turbine.UI.Lotro.Quickslot();		
	self.quickslot5:SetParent( self );
	self.quickslot5:SetZOrder(100);
	self.quickslot5:SetSize(36, 36);
	self.quickslot5:SetPosition(144 , self.height/36)
	self.quickslot5:SetShortcut( Turbine.UI.Lotro.Shortcut ( 6.0,  debuffs.frostlore ));
	
	self.quickslot6 = Turbine.UI.Lotro.Quickslot();		
	self.quickslot6:SetParent( self );
	self.quickslot6:SetZOrder(100);
	self.quickslot6:SetSize(36, 36);
	self.quickslot6:SetPosition(180, self.height/36)
	self.quickslot6:SetShortcut( Turbine.UI.Lotro.Shortcut ( 6.0,  debuffs.sopc ));
	
	self.quickslot7 = Turbine.UI.Lotro.Quickslot();		
	self.quickslot7:SetParent( self );
	self.quickslot7:SetZOrder(100);
	self.quickslot7:SetSize(36, 36);
	self.quickslot7:SetPosition(216, self.height/36)
	self.quickslot7:SetShortcut( Turbine.UI.Lotro.Shortcut ( 6.0,  debuffs.gustofwind ));
	
	self.Control1=Turbine.UI.Control();
	self.Control1:SetParent(self);
	self.Control1:SetSize(31,31);
	self.Control1:SetBackground("Iinferno/debuffhelper/media/dragger.tga"); 
	self.Control1:SetPosition(255, self.height/10)
	self.Control1:SetOpacity(0.5)
	--Iinferno.debuffhelper.skillhelper.SkillInfo.SkillInfoWindow:getCooldown("Fire-lore")
	--[[self.quickslot5.MouseClick=function()
		self.quickslot5:SetVisible(false);
	end]]
	self:LoadSettings();
	self.Control1.MouseDown = function(sender, args )
		if (args.Button == Turbine.UI.MouseButton.Left) then
			isMoving = true;
			x = args.X;
			y = args.Y;
			
		end
	end
	self.Control1.MouseUp = function(sender, args )
		if (args.Button == Turbine.UI.MouseButton.Left) then
			isMoving = false;
			local one,two = self:GetPosition();
			self.settings.positionX = one;
			self.settings.positionY = two;
			self:SaveSettings();
		end
	end
	
	self.Control1.MouseMove = function(sender, args )
		if (isMoving) then
			local oldX,oldY = self:GetPosition();
			self:SetPosition(oldX + args.X - x,oldY + args.Y - y);	
		end
		
	end
	
end

function AddCallback(object, event, callback)
	if (object[event] == nil) then
		object[event] = callback;
		else
		if (type(object[event]) == "table") then
			table.insert(object[event], callback);
			else
			object[event] = {object[event], callback};
		end
	end
end
function Split(str)
	--local numchar = ""
	local stringArray = { }
	--local temp = "%a"
	local s
	for i = 1 , string.len(str) do 
		s = findpattern(str,".", i) --find the first letter of s
		stringArray[i] = s --store that letter in an array to be returned (split string)
		--numchar = numchar .. "." --add another wildcard to the beginning of temp
		--temp = numchar .. temp --allows s to find the next letter of the string instead
		--of repeating
	end
	return stringArray
	
end
function arrayLen(array)
	i = 1 --until the array says 'nill' incrament i, then return i (length)
	while array[i] ~= nil do
		i = i + 1
	end
	return i
end
function strjoin(array)
	local len = arrayLen(array)
	local str = tostring(array[1])
	for i = 2, len - 1 do
		str = str .. tostring(array[i]) -- error: attempt to contactenate field (?) a nil value
	end
	return str
end

function findPhrase(msg,phrase)
	--firelore = {"F", "i", "r", "e", "-", "l", "o", "r", "e"}
	--for i = 0, string.len(phrase) do
	--	if phrase[i] = 
	local splitMsg = Split(msg)	-- split the strings into an array:
	local splitPhrase = Split(phrase)
	result = { } -- array to store the results after the message is found
	local firstOccur = string.find(msg, findpattern(phrase,".")) --finds the first occurance of a letter in phrase
	if firstOccur ~= nil then
		for i = 1, string.len(phrase) do 
			result[i] = splitMsg[firstOccur + (i - 1)]	--stores the results of letters after the occurance of the first letter in the phrase, up to the last letter of the length of the phrase
		end
		
		resultStr = ""
		--for i=1, arrayLen(result) do
		
		--[[end
			for i=1, arrayLen(splitPhrase) do
			Turbine.Shell.WriteLine(splitPhrase[i])
			end
			for i=1, arrayLen(splitMsg) do
			Turbine.Shell.WriteLine(splitMsg[i])
			end
			--resultStr = strjoin(result)
		]]
		resultStr = strjoin(result)
		if resultStr == phrase then
			
			return true --checks if the result is the same as  phrase
		end
	end
end
function findpattern(text, pattern, start) 
	if start == nil then
		return string.sub(text, string.find(text,pattern))
		else
		return string.sub(text, string.find(text,pattern,start))
	end
end

function debuffBar:LoadSettings()
	
	self.loading = true;
	
	local settingStrings = Turbine.PluginData.Load( Turbine.DataScope.Character, "debuffhelperSettings" );
	self.settings = { };
	
	if ( type( settingStrings ) ~= "table" ) then
		settingStrings = { };
	end
	
	if ( not settingStrings.positionX or settingStrings.positionX == "nil" ) then
		settingStrings.positionX = tostring(Turbine.UI.Display.GetWidth() - self:GetWidth() - 250); 
	end
	
	if ( not settingStrings.positionY or settingStrings.positionY == "nil" ) then
		settingStrings.positionY = tostring(Turbine.UI.Display.GetHeight() - self:GetHeight() - 150 * 1.5);
	end
	
	if ( not settingStrings.orientation or settingStrings.orientation == "nil" ) then
		settingStrings.orientation = tostring(1);
	end
	
	
	-- convert from strings if necessary   
	if(type( settingStrings.positionX ) == "string" ) then
		self.settings.positionX = tonumber(settingStrings.positionX);
		else
		self.settings.positionX = settingStrings.positionX;
	end  
	
	if(type( settingStrings.positionY ) == "string" ) then
		self.settings.positionY = tonumber(settingStrings.positionY);
		else
		self.settings.positionY = settingStrings.positionY;
	end
	
	if(type( settingStrings.orientation ) == "string" ) then
		self.settings.orientation = tonumber(settingStrings.orientation);
		else
		self.settings.orientation = settingStrings.orientation;
	end
	
	
	self.loading = false;
end
function debuffBar:SaveSettings()
	if (self.loading) then
		return;
	end
	
	settingStrings = { };
	

	settingStrings.positionX = tostring(self.settings.positionX);
	settingStrings.positionY = tostring(self.settings.positionY);
	settingStrings.orientation = tostring(self.settings.orientation);
	
	settingStrings.shortcuts = { };
	
	Turbine.PluginData.Save( Turbine.DataScope.Character, "debuffhelperSettings", settingStrings );
end

AddCallback(Turbine.Chat,"Received",function(sender, args)
	msg = string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","")
	
	--Turbine.Shell.WriteLine("startTime:" .. tostring(math.floor(startTime)))
	--Turbine.Shell.WriteLine("currentTime:" .. tostring(math.floor(bar1.currentTime)))
	--Turbine.Shell.WriteLine(delta)
	
	if findPhrase(msg,"Call to the Valar") == true then
		
		bar1.quickslot3:SetVisible(true)
		bar1.quickslot4:SetVisible(true)
		bar1.quickslot5:SetVisible(true)
		
		timer3:SetTime(1, false)
		timer4:SetTime(1, false)
		timer5:SetTime(1, false)
	end
	
	
	if findPhrase(msg,"Sign of Power: See All Ends") == true then
		bar1.quickslot1:SetVisible(false)
		timer1:SetTime(60, true)
		AddCallback(timer1,"TimeReached",function() 
			bar1.quickslot1:SetVisible(true)
		end)
		--while delta < 60 do
		--currentTime = Turbine.Engine.GetGameTime()
		--delta = math.floor(currentTime) - math.floor(startTime)
		--end
		--Turbine.Shell.WriteLine("yay")
		end
		--cTTV reset
		
		if findPhrase(msg,"Ancient Craft") == true then
			bar1.quickslot2:SetVisible(false)
			timer2:SetTime(60, true)
			AddCallback(timer2,"TimeReached",function() 
				bar1.quickslot2:SetVisible(true)
			end)
			--while delta < 60 do
			--currentTime = Turbine.Engine.GetGameTime()
			--delta = math.floor(currentTime) - math.floor(startTime)
			--end
			--Turbine.Shell.WriteLine("yay")
		end
		if findPhrase(msg,"Wind-lore") == true then
			bar1.quickslot3:SetVisible(false)
			timer3:SetTime(30, true)
			AddCallback(timer3,"TimeReached",function() 
				bar1.quickslot3:SetVisible(true)
			end)
			--while delta < 60 do
			--currentTime = Turbine.Engine.GetGameTime()
			--delta = math.floor(currentTime) - math.floor(startTime)
			--end
		--Turbine.Shell.WriteLine("yay")
	end
	if findPhrase(msg,"Fire-lore") == true then
		bar1.quickslot4:SetVisible(false)
		timer4:SetTime(60, true)
		AddCallback(timer4,"TimeReached",function() 
			bar1.quickslot4:SetVisible(true)
		end)
		--while delta < 60 do
		--currentTime = Turbine.Engine.GetGameTime()
		--delta = math.floor(currentTime) - math.floor(startTime)
		--end
		--Turbine.Shell.WriteLine("yay")
	end
	if findPhrase(msg,"Frost-lore") == true then
		bar1.quickslot5:SetVisible(false)
		timer5:SetTime(60, true)
		AddCallback(timer5,"TimeReached",function() 
			bar1.quickslot5:SetVisible(true)
		end)
		
		--while delta < 60 do
		--currentTime = Turbine.Engine.GetGameTime()
		--delta = math.floor(currentTime) - math.floor(startTime)
		--end
		--Turbine.Shell.WriteLine("yay")
	end
	if findPhrase(msg,"Sign of Power: Command") == true then
		bar1.quickslot6:SetVisible(false)
		timer6:SetTime(2.6, true)
		AddCallback(timer6,"TimeReached",function() 
			bar1.quickslot6:SetVisible(true)
		end)
	end
	if findPhrase(msg,"Gust of Wind") == true then
		bar1.quickslot7:SetVisible(false)
		timer7:SetTime(10, true)
		AddCallback(timer7,"TimeReached",function() 
			bar1.quickslot7:SetVisible(true)
		end)
	end
end )
timer1=Timer();
timer2=Timer();
timer3=Timer();
timer4=Timer();
timer5=Timer();
timer6=Timer();
timer7=Timer();
bar1 = debuffBar();
